<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>COMMENT DETAIL</title>
</head>

<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gBASE_URL = "https://jsonplaceholder.typicode.com/";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function() {
        // gán sự kiện load trang
        onPageLoading();
    })
    
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // function xử lý sự kiện tải trang/F5
    function onPageLoading() {
        // B1: Thu thập dữ liệu
        let vCommentId = getCommentId();
        console.log("%cCOMMENT ID: " + vCommentId, "color: green");
        // B2: Kiểm tra dữ liệu
        let vDataValid = checkCommentId(vCommentId);
        if (vDataValid) {
            // B3: Gọi API lấy comment detail bằng comment ID
            let vAjaxRequest = callApiGetCommentDetailById(vCommentId);
            vAjaxRequest.done(function(vResponse) {
                console.log("Response Object:");
                console.log(vResponse);
                displayCommentDetail(vResponse);
            })
        }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // function thu thập dữ liệu Comment ID trên URL
    function getCommentId() {
        let vUrl = new URL(window.location.href);
        let vCommentId = vUrl.searchParams.get("id");
        return vCommentId;
    }

    // function kiểm tra dữ liệu Comment ID
    // function return true nếu tất cả dữ liệu hợp lệ, return false nếu có dữ liệu không hợp lệ
    function checkCommentId(paramCommentId) {
        if (paramCommentId === "") {
            alert("Comment ID not exist");
            return false;
        }
        return true;
    }

    // function gọi API lấy post detail bằng post id
    function callApiGetCommentDetailById(paramCommentId) {
        let vAjaxRequest = $.ajax({
            url: gBASE_URL + "comments/" + paramCommentId,
            type: "GET",
        })
        return vAjaxRequest;
    }

    // function hiển thị comment detail lên form
    function displayCommentDetail(paramCommentData) {
        $("#inp-comment-id").val(paramCommentData.id);
        $("#inp-post-id").val(paramCommentData.postId);
        $("#inp-email").val(paramCommentData.email);
        $("#inp-title").val(paramCommentData.name);
        $("#inp-content").val(paramCommentData.body);
    }

</script>

<body>
    <div class="container jumbotron">
        <div class="row form-group">
            <div class="col-sm-12 text-center">
                <h3><span class="text-success border-bottom"><b>COMMENT DETAIL</b></span></h3>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label class="col-form-label">Comment ID</label>
            </div>
            <div class="col-sm-9">
                <input id="inp-comment-id" class="form-control" placeholder="Comment ID ...">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label class="col-form-label">Post ID</label>
            </div>
            <div class="col-sm-9">
                <input id="inp-post-id" class="form-control" placeholder="Post ID ...">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label class="col-form-label">Email</label>
            </div>
            <div class="col-sm-9">
                <input id="inp-email" class="form-control" placeholder="Email ...">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label class="col-form-label">Title</label>
            </div>
            <div class="col-sm-9">
                <input id="inp-title" class="form-control" placeholder="Comment Title ...">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label class="col-form-label">Content</label>
            </div>
            <div class="col-sm-9">
                <textarea rows="5" id="inp-content" class="form-control" placeholder="Comment Content ..."></textarea>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-12 text-right">
                <a href="commentList.html">Back to Comment List</a>
            </div>
        </div>
    </div>
</body>
</html>